import sys,os
from PyQt5.QtWidgets import QApplication, QMainWindow, QPushButton, QWidget, QAction,qApp,QInputDialog,QDialog,QMessageBox
from PyQt5 import QtCore, QtGui, QtWidgets
from PyQt5.QtCore import QTimer

from threading  import Thread
import threading
import time 
import schedule
import json
import psutil
import subprocess

from module.pyConsole import *
from module.minecraft_update import *
from ui.mainwindow import *
from ui.server_console import *
from ui.setting import *
from ui.dialog import *

class UIWindow(object):
    def setupUI(self, MainWindow):
        MainWindow.setWindowTitle("UIWindow")
        self.centralwidget = QWidget(MainWindow)
        # mainwindow.setWindowIcon(QtGui.QIcon('PhotoIcon.png'))c
        self.ToolsBTN = QPushButton('text', self.centralwidget)
        self.ToolsBTN.move(50, 250)
        MainWindow.setCentralWidget(self.centralwidget)





class HelloWorldGui(QMainWindow, Ui_MainWindow):
    def __init__(self, parent=None):
        super(HelloWorldGui, self).__init__(parent)
        self.setupUi(self)
        #変数
        ##サーバーログ
        self.server_log=[]
       
        #画面登録
        self.uiWindow = UIWindow()
        self.console_ui = Ui_server_console_ui()
        self.setting_dialog=server_setting_window(self)
        self.message_dialog=message_dialog(self)

         #メインウィンドウアクション登録
        self.save_world.triggered.connect(lambda: self.Minecraft_process.input_std("save-all\r\n"))
        self.server_start_stop.triggered.connect(self.server_start_stop_action)
        self.setting.triggered.connect(lambda: self.start_setting_dialog())


        self.start_console_ui()
        self.Minecraft_process=Process_Terminal()
        #タイマー割り込み
        ##サーバーログ更新
        self.server_log_update_timer = QTimer(self)
        self.server_log_update_timer.timeout.connect(self.server_log_update)
        self.server_log_update_timer.start(100)#ミリ秒単位
        ##スケジューラー実行
        self.schedule_run_timer = QTimer(self)
        self.schedule_run_timer.timeout.connect(schedule.run_pending)
        self.schedule_run_timer.start(1000)
        ##スケジューラー更新
        self.schedule_update_timer = QTimer(self)
        self.schedule_update_timer.timeout.connect(self.schedule_registration)
        self.schedule_update_timer.start(60000)
        ##
        self.title_update_timer = QTimer(self)
        self.title_update_timer.timeout.connect(self.update_title_name)
        self.title_update_timer.start(1000)

        

        

        self.schedule_data=dict()
        self.server_config={}
        try:
            with open("server_config.json") as f:
                self.server_config = json.load(f)
        except:
            init_make_file()
            self.server_config={"java_command":"java",
               "java_argument":" -jar -server -XX:MetaspaceSize=512M -XX:+UseG1GC -XX:+UseStringDeduplication -XX:+DisableExplicitGC -XX:+UseCompressedOops -XX:+OptimizeStringConcat -XX:+UseTLAB",
               "server_jar":"server.jar",
               "server_jar_argument":"nogui",
               "memory":"1024"
               }
        self.command=" ".join([self.server_config["java_command"],self.server_config["java_argument"],"-Xms"+ self.server_config["memory"]+ "M","-Xmx"+ self.server_config["memory"]+ "M", "-jar", self.server_config["server_jar"], self.server_config["server_jar_argument"]])

    def closeEvent(self,event):
        if self.Minecraft_process.process_run_state():
            confirmObject = QMessageBox.question(self,'警告',
            'サーバーは現在起動中です\nシャットダウンを行いますか？',QMessageBox.Yes |
            QMessageBox.No,QMessageBox.No)
            if confirmObject ==QMessageBox.Yes:
                self.Minecraft_process.input_std("stop\r\n")
                while self.Minecraft_process.process_run_state():
                    time.sleep(0.1)
                event.accept()
            else:
                event.ignore()
        else:
            event.accept()
    def update_title_name(self):
        if self.Minecraft_process.process_run_state():
            self.setWindowTitle("minecraft サーバー管理  サーバー起動中")
        else:
            self.setWindowTitle("minecraft サーバー管理  サーバー停止中")

    def server_start_action(self):
        if self.Minecraft_process.process_run_state():
            pass
        else:
            if os.path.isfile("./server/"+self.server_config["server_jar"]):
                self.Minecraft_process.execute_process(self.command,"./server/")
            else:
                self.message_dialog.show("サーバーファイル"+"「./server/"+self.server_config["server_jar"]+"」\nが見つかりませんでした。\n設定からサーバーをダウンロードしてください。")
    def server_stop_action(self):
        if self.Minecraft_process.process_run_state():
            self.Minecraft_process.input_std("stop\r\n")
        else:
            pass

    def server_start_stop_action(self):
        if self.Minecraft_process.process_run_state():
            self.Minecraft_process.input_std("stop\r\n")
        else:
            if os.path.isfile("./server/"+self.server_config["server_jar"]):
                self.Minecraft_process.execute_process(self.command,"./server/")
            else:
                self.message_dialog.show("サーバーファイル"+"「./server/"+self.server_config["server_jar"]+"」\nが見つかりませんでした。\n設定からサーバーをダウンロードしてください。")


    def server_log_update(self):
        self.server_log.extend(self.Minecraft_process.read_std())
        
        

    def server_display_update(self):
        #オートスクロールが有効の時
        if self.console_ui.auto_scroll.isChecked():
        
            scrollbar = self.console_ui.server_console.verticalScrollBar()
            value=scrollbar.value()

            self.console_ui.server_console.setText("\r\n".join(self.server_log)+"\r\n")

            scrollbar = self.console_ui.server_console.verticalScrollBar()
            scrollbar.setValue(scrollbar.maximum())

        else:
            pass


    def schedule_registration(self):
        schedule_data={}
        try:
            with open("command_schedule.json") as f:
                schedule_data = json.load(f)
        except:
            self.schedule_data=schedule_data
            schedule.clear()

        if self.schedule_data==schedule_data:
            return True
        else:
            self.schedule_data=schedule_data
            schedule.clear()
            for label in schedule_data.keys():
                if ('type' in schedule_data[label]) and ("time" in schedule_data[label]) and ("command" in schedule_data[label]):
                    if schedule_data[label]["command"]=="None":
                        break
                    if schedule_data[label]["type"]=="day":
                        if schedule_data[label]["command"]=="server_start" :
                            schedule.every().day.at(schedule_data[label]["time"]).do(self.server_start_action)
                        elif  schedule_data[label]["command"]=="server_stop":
                            schedule.every().day.at(schedule_data[label]["time"]).do(self.server_stop_action)
                        else:
                            schedule.every().day.at(schedule_data[label]["time"]).do(lambda: self.Minecraft_process.input_std(schedule_data[label]["command"]+"\r\n"))
                    if schedule_data[label]["type"]=="every_minutes":
                        if schedule_data[label]["command"]=="server_start":
                            schedule.every(int(schedule_data[label]["time"])).minutes.do(self.server_start_action)
                        elif schedule_data[label]["command"]=="server_stop":
                            schedule.every(int(schedule_data[label]["time"])).minutes.do(self.server_stop_action)
                        else:
                            schedule.every(int(schedule_data[label]["time"])).minutes.do(lambda: self.Minecraft_process.input_std(schedule_data[label]["command"]+"\r\n"))
                    if schedule_data[label]["type"]=="every_hours":
                        if schedule_data[label]["command"]=="server_start":
                            schedule.every(int(schedule_data[label]["time"])).hours.do(self.server_start_action)
                        elif schedule_data[label]["command"]=="server_stop":
                            schedule.every(int(schedule_data[label]["time"])).hours.do(self.server_stop_action)
                        else:
                            schedule.every(int(schedule_data[label]["time"])).hours.do(lambda: self.Minecraft_process.input_std(schedule_data[label]["command"]+"\r\n"))
    
    def start_console_ui(self):
        self.console_ui.setupUi(self)    
        #ボタンイベント登録    
        ##送信ボタンが押された時
        self.console_ui.send_command.clicked.connect(self.send_command_event)  
        #タイマー割り込み
        ##サーバーログ表示更新
        self.server_display_update_timer = QTimer(self)
        self.server_display_update_timer.timeout.connect(self.server_display_update)
        self.server_display_update_timer.start(500)#ミリ秒単位
        self.show()
        

    def send_command_event(self):
        text=self.console_ui.server_input.text()
        self.Minecraft_process.input_std(text+"\r\n")
        self.console_ui.server_input.setText("")  

    def startUIWindow(self):
        self.uiWindow.setupUI(self)
        self.uiWindow.ToolsBTN.clicked.connect(self.startUIserver_console_Tab)
        self.show()
    def start_setting_dialog(self):
        if self.Minecraft_process.process_run_state():
            self.message_dialog.show("サーバーが起動中です\n停止してください。")
        else:
            self.setting_dialog.show()

class server_setting_window(QDialog):
    def __init__(self, parent=None):
        QDialog.__init__(self, parent)
        self.setting = Ui_setting()
        self.setting.setupUi(self)
        self.minecraft_updater=minecraft_update_tool()
        self.message_dialog=message_dialog(self)
    def update_memory_dislpay(self):
        memory_mb=(psutil.virtual_memory().total/(1024**2))*(self.setting.memory_slider.value()/100)
        self.setting.memory_MB.display(int(memory_mb))
    def open_server_properties(self):
        subprocess.Popen(["start", "./server/server.properties"], shell=True)



    def show(self):

        try:
            with open("server_config.json") as f:
                self.server_config = json.load(f)
        except:
            init_make_file()
            self.server_config={"java_command":"java",
               "java_argument":" -jar -server -XX:MetaspaceSize=512M -XX:+UseG1GC -XX:+UseStringDeduplication -XX:+DisableExplicitGC -XX:+UseCompressedOops -XX:+OptimizeStringConcat -XX:+UseTLAB",
               "server_jar":"server.jar",
               "server_jar_argument":"nogui",
               "memory":"1024"
               }
        print(self.server_config)
        self.setting.open_server_properties.clicked.connect(self.open_server_properties)
        self.setting.memory_MB.display(int(self.server_config["memory"]))
        self.setting.checkBox.setChecked(get_eula())

        for version in self.minecraft_updater.get_release_version_list():
            self.setting.comboBox.addItem(version)
        self.setting.memory_slider.valueChanged.connect(self.update_memory_dislpay)
        if self.exec_():
            self.message_dialog.show("サーバーをダウンロードします\n続行するにはこのウインドウを閉じてください。")
            self.minecraft_updater.server_change(self.setting.comboBox.currentText())
            self.server_config["memory"]=str(int(self.setting.memory_MB.value()))
            server_config_json = json.dumps(self.server_config)
            with open("server_config.json", mode='w') as f:
                f.write(server_config_json)
            set_eula(self.setting.checkBox.isChecked())
            self.command=" ".join([self.server_config["java_command"],self.server_config["java_argument"],"-Xms"+ self.server_config["memory"]+ "M","-Xmx"+ self.server_config["memory"]+ "M", "-jar", self.server_config["server_jar"], self.server_config["server_jar_argument"]])
            self.message_dialog.show("設定が完了しました。")

class message_dialog(QDialog):
    def __init__(self, parent=None):
        QDialog.__init__(self, parent)
        self.dialog = Ui_Dialog()
        self.dialog.setupUi(self)

    def show(self,message):
        self.dialog.message.setText(message)
        self.exec_()

def init_make_file():
    server_config={"java_command":"java",
               "java_argument":" -jar -server -XX:MetaspaceSize=512M -XX:+UseG1GC -XX:+UseStringDeduplication -XX:+DisableExplicitGC -XX:+UseCompressedOops -XX:+OptimizeStringConcat -XX:+UseTLAB",
               "server_jar":"server.jar",
               "server_jar_argument":"nogui",
               "memory":"1024"
               }
    schedule_data={"test":{"type":"day",
                       "time":"10:00",
                       "command":"None"},
               "test2":{"type":"every_hours",
                        "time":"5",
                        "command":"None"},
               "test3":{"type":"every_minutes",
                        "time":"1",
                        "command":"None"},
               "test4":{"type":"every_minutes",
                        "time":"1",
                        "command":"None"},
                "test5":{"type":"every_minutes",
                        "time":"1",
                        "command":"None"}
              }
    if not(os.path.isdir("./server")):
        os.makedirs("./server")
    if not(os.path.isfile("server_config.json")):
        server_config_json = json.dumps(server_config)
        with open("server_config.json", mode='w') as f:
            f.write(server_config_json)
    if not(os.path.isfile("command_schedule.json")):
        schedule_data_json = json.dumps(schedule_data)
        with open("command_schedule.json", mode='w') as f:
            f.write(schedule_data_json)

def get_eula():
    eula="#By changing the setting below to TRUE you are indicating your agreement to our EULA(https://account.mojang.com/documents/minecraft_eula).\r\neula=FALSE"
    if not (os.path.isfile("./server/eula.txt")):
        with open("./server/eula.txt", mode='w') as f:
            f.write(eula)
        return False
    else:
        lines=[]
        with open("./server/eula.txt") as f:
            lines=f.readlines()
        for line in lines:
            if "eula=" in line:
                if "TRUE" in line or "true" in line or "True" in line:
                    return True
                else:
                    return False
def set_eula(bool_):
    eula_FALSE="#By changing the setting below to TRUE you are indicating your agreement to our EULA(https://account.mojang.com/documents/minecraft_eula).\r\neula=FALSE"
    eula_TRUE="#By changing the setting below to TRUE you are indicating your agreement to our EULA(https://account.mojang.com/documents/minecraft_eula).\r\neula=TRUE"
    with open("./server/eula.txt", mode='w') as f:
        if bool_:
            f.write(eula_TRUE)
        else:
            f.write(eula_FALSE)



if __name__ == '__main__':
    init_make_file()
    app = QApplication(sys.argv)
    w = HelloWorldGui()
    sys.exit(app.exec_())