import urllib.request
import json
import os
import glob
import shutil
class minecraft_update_tool:
    def __init__(self):
        self.url="https://launchermeta.mojang.com/mc/game/version_manifest.json"
        pass
    def __dataGet(self,url):
        try:
            readObj = urllib.request.urlopen(url)
            response = readObj.read()
            return response
        except:
            return False
    def __save_file(self,file_path,binary_data):
        try:
            os.makedirs("/".join(file_path.split("/")[:-1]))
        except FileExistsError:
            pass
        try:
            with open(file_path, mode="wb") as f:
                f.write(binary_data)
            return True
        except:
            return False
    # webAPIから取得したデータをJSONに変換
    def __jsonConversion(self,jsonStr):
        if jsonStr==False:
            return False
        else:
            data = json.loads(jsonStr)
            return data
    def __get_version_list(self,release_id):
        json_data=self.__jsonConversion(self.__dataGet(self.url))
        if json_data==False:
            return False
        release_version_list=[]
        for version in json_data["versions"]:
            if (version["type"]==release_id) or release_id=="all" :
                release_version_list.append(version["id"]) 
        return release_version_list
    def __get_download_url(self,version):
        json_data=self.__jsonConversion(self.__dataGet(self.url))
        if json_data==False:
            return False
        version_json_url=""
        for version_json in json_data["versions"]:
            if  version == str(version_json["id"]) :
                version_json_url=version_json["url"]
                break
        if version_json_url=="":
            return False
        json_data=self.__jsonConversion(self.__dataGet(version_json_url))
        return json_data["downloads"]["server"]["url"]
    def get_server_jar(self,version,save_path="./server_jar"):
    

        if os.path.exists(save_path+"/"+version+"_server.jar"):
            return True
        url=self.__get_download_url(version)
        if not(url) or url==False:
            return False
        else:
            binary_data=self.__dataGet(url)
            if binary_data==False:
                return False
            else:
                return self.__save_file(save_path+"/"+version+"_server.jar",binary_data)
    def get_release_version_list(self):
        return self.__get_version_list("release")
    def get_snapshot_version_list(self):
        return self.__get_version_list("snapshot")
    def get_all_version_list(self):
        return self.__get_version_list("all")
    def server_change(self,version):
        self.get_server_jar(version)
        server_jar_files = glob.glob('./server_jar/*.jar')
        server_jar_file=""
        for server_jar in server_jar_files:
            if version == server_jar.replace("\\","/").split("/")[-1].split("_")[0]:
                server_jar_file=server_jar
        if server_jar_file=="":
            return False
        shutil.copyfile(server_jar_file, "./server/server.jar")
        return 

        